# Edujin_SOAP

> Dibuat untuk memenuhi Tugas Besar Milestone 2 IF3110 _Web Based Development_ - _Web Services using SOAP and REST_.

## Daftar Isi

- [Deskripsi _Web Service_](#deskripsi-web-service)
- [_Requirement_](#requirement)
- [Cara Instalasi](#cara-instalasi)
- [Cara Menjalankan _Server_](#cara-menjalankan-server)
- [Skema Basis Data](#skema-basis-data)
- [_Endpoint_ API](#endpoint-api)
- [Pembagian Tugas](#pembagian-tugas)

## Deskripsi _Web Service_

Edujin SOAP API merupakan sebuah layanan yang memungkinkan aplikasi Edujin untuk memanfaatkan fungsionalitas yang dimiliki oleh
sistem lain. Fungsionalitas ini berupa _email forget password_, layanan _subscribe_, dan artikel premium. SOAP _Service_ ini dikembangkan dengan memanfaatkan bahasa Java dengan kakas JAX-WS.

## _Requirement_

Untuk menjalankan layanan, diharapkan telah menginstall

- [Docker Engine](https://docs.docker.com/engine/install/)

## Cara Instalasi

1. _Clone repository_ ini dengan perintah

    ```bash
    git clone https://gitlab.informatika.org/IF3110-2023-02-40/edujin-soap.git
    ```

    atau dengan mengunduh _source code_ secara langsung.
2. Pastikan bahwa komputer Anda telah meng-_install_ dan menjalankan aplikasi Docker.
3. Buatlah sebuah file `.env` yang sesuai untuk penggunaan layanan (contoh dapat dilihat pada file `.env.example`)

## Cara Menjalankan _Server_

1. Jalankan _web service_ dengan menjalankan perintah berikut pada terminal.

    ```bash
    docker compose up -d --build
    ```

2. _Web service_ dapat diakses dengan _browser_ pada URL `http://localhost:8082`.
3. _Web service_ dapat dihentikan dengan menjalankan perintah berikut pada terminal.

    ```bash
    docker compose down
    ```

## Skema Basis Data

![SOAP Database](./assets/SOAP_Database.png)

## _Endpoint_ API

Berikut merupakan daftar _endpoint_ API yang disediakan oleh layanan Edujin SOAP:

- /reset: _Endpoint_ untuk melakukan _reset password_ akun pengguna.
- /subscribe: _Endpoint_ untuk melakukan _subscribe_ akun pengguna.

## Pembagian Tugas

| Layanan SOAP              | NIM      |
| ------------------------- | -------- |
| Fungsi Logging            | 13521110 |
| Fungsi Subscription       | 13521062 |
| Fungsi _Forget Password_  | 13521045 |