package edujin.repository;

import edujin.model.Email;
import edujin.util.ConfigHandler;
import io.github.cdimascio.dotenv.Dotenv;

import java.io.UnsupportedEncodingException;

public class PasswordResetTokenRepository extends TokenRepository{
    private static PasswordResetTokenRepository instance = null;
    private PasswordResetTokenRepository() {
        super();
        expiryDurationHours = Long.parseLong(Dotenv.load().get("PASSWORD_RESET_EXPIRE_HOURS"));
        expiryDurationMinutes = Long.parseLong(Dotenv.load().get("PASSWORD_RESET_EXPIRE_MINUTES"));
    }
    public static PasswordResetTokenRepository getInstance() {
        if (instance == null) {
            instance = new PasswordResetTokenRepository();
        }
        return instance;
    }
    @Override
    public void sendEmail(String userEmail, String newToken) throws UnsupportedEncodingException {
        System.out.println("Sending email to " + userEmail);
        Email resetEmail = new Email(userEmail);
        ConfigHandler configHandler = ConfigHandler.getInstance();
        String edujinAppUrl = configHandler.get("edujin_app.url");
        String body = "Please click the link below to reset your password: \n" +
                edujinAppUrl + "/reset?token=" + newToken;
        resetEmail.setSubjectEmail("Reset Password");
        resetEmail.setBodyEmail(body);
        resetEmail.sendEmail();
    }
}
